-- MAX+plus II VHDL Template
-- Clearable loadable enablable counter

LIBRARY ieee;
USE ieee.std_logic_1164.all;
LIBRARY work;
USE work.defines.all;
ENTITY onebitalu IS
		port(
			x, y: std_logic;
			fn: in std_logic_vector(1 downto 0);
			cin: in std_logic;
			const1, enablex, compy: std_logic;
			Q: out std_logic;
			cout: out std_logic
		);	
END onebitalu;

architecture a of onebitalu is
	signal xsig, ysig, xory, xandy, xxory: std_logic;
begin
	xsig <= (x and enablex) or const1;
	ysig <= y xor compy;
	xory <= xsig or ysig;
	xandy <= xsig and ysig;
	xxory <= xsig xor ysig;
	Q <= xxory xor cin when fn=ADDFN else
		 xory when fn = ORFN else
		 xandy  when fn = ANDFN else
		 xxory;
	cout <= (xsig and cin ) or (ysig and cin) or xandy;
end a;
----------------------------
-----------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
LIBRARY work;
USE work.defines.all;

ENTITY alu IS

	PORT
	(
		X, Y: in std_logic_vector(wordsize-1 downto 0);
		auxin: in std_logic_vector(5 downto 0);
		
		Q: out std_logic_vector(wordsize-1 downto 0);
		cout, zflag, nflag, ovflag: out std_logic
	);
	
END alu;

ARCHITECTURE a OF alu IS
	component onebitalu 
		port(
			x, y: std_logic;
			fn: in std_logic_vector(1 downto 0);
			cin: in std_logic;
			const1, enablex, compy: std_logic;
			Q: out std_logic;
			cout: out std_logic
		);	
	end component;
	signal coS, Qs: std_logic_vector(wordsize-1 downto 0);
	signal ovS: std_logic;
	signal cin,	const1, enablex, compy: std_logic;
	signal fn: std_logic_vector(1 downto 0);

BEGIN
	cin <= auxin(0);
	const1 <= auxin(1);
	enablex <= auxin(2);
	compy <= auxin(3);
	fn <= auxin(5 downto 4);

	bit0: onebitalu port map
		(X(0), Y(0), fn, cin, const1, enablex, compy, 
		Qs(0), coS(0));
	gen_loop: for K in 1 to wordsize-1 generate
		bitK: onebitalu port map
		(X(K), Y(K), fn, coS(K-1), const1, enablex, compy, 
			Qs(K), coS(K));
	end generate;
	cout <= coS(wordsize-1) when fn=ADDFN else
			'0';
	Q <= Qs;
	zflag <= '1' when Qs = ZERO_WORD else
			'0';
	nflag <= Qs(wordsize-1);
	ovS <= X(wordsize-1) xor Y(wordsize-1) xor Qs(wordsize-1) xor coS(wordsize-1);
	ovflag <= ovS when fn=ADDFN else
		'0';
END a;


