-- MAX+plus II VHDL Template
-- Clearable flipflop with enable

LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE defines IS
	constant wordsize: integer :=16;
	constant ZEROBYTE: std_logic_vector(7 downto 0) := "00000000";
	constant ZERO_DBL_BYTE: std_logic_vector( 15 downto 0) := ZEROBYTE&ZEROBYTE;
	constant ZERO_WORD: std_logic_vector( wordsize-1 downto 0) := ZERO_DBL_BYTE;




-- ALU
	constant ADDFN: std_logic_vector(1 downto 0) := "00";
	constant  ORFN: std_logic_vector(1 downto 0) := "01";
	constant ANDFN: std_logic_vector(1 downto 0) := "10";
	constant XORFN: std_logic_vector(1 downto 0) := "11";


    -- Selecting alufns
	--                                               fn    compy enx  cnst1  cin													
	constant INCY: std_logic_vector(5 downto 0) := ADDFN & "0" & "0" & "0" & "1";
	constant NEGY: std_logic_vector(5 downto 0) := ADDFN & "1" & "0" & "0" & "1";
	constant COMY: std_logic_vector(5 downto 0) := ADDFN & "1" & "0" & "0" & "0";
	constant PSSY: std_logic_vector(5 downto 0) :=  ORFN & "0" & "0" & "0" & "0";
	constant ADD:  std_logic_vector(5 downto 0) := ADDFN & "0" & "1" & "0" & "0";
	constant ADDC:  std_logic_vector(5 downto 0) := ADDFN & "0" & "1" & "0" & "1";

END defines;

